// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "aw1.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView
/*----------------------------------------------------------*/	
/* konstruktor klasu CChildView */
CChildView::CChildView()
{
	tekstura.ustaw_kolor_w_tablicy(RGB(255,255,255)); // stworzenie bialej tablicy zachowujacej obraz;
	
	currentColor=RGB(0,0,0);
	is_copy_empty=true;
	is_drawing=false;
}
/*----------------------------------------------------------*/	
/* destruktor klasu CChildView */
CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_SAVE, OnSave)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_EFFECTS_EFFECT1, OnEffectsEffect1)
	ON_COMMAND(ID_EFFECTS_GRAYSCALE, OnEffectsGrayscale)
	ON_COMMAND(ID_EFFECTS_BRIGHTNESS_LIGHT, OnEffectsBrightnessLight)
	ON_COMMAND(ID_EFFECTS_BRIGHTNESS_NORMAL, OnEffectsBrightnessNormal)
	ON_COMMAND(ID_EFFECTS_BRIGHTNESS_HEAVY, OnEffectsBrightnessHeavy)
	ON_COMMAND(ID_VIEW_CHOOSECOLORDIALOG, OnViewChoosecolordialog)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_FILE_LOADBMP, OnFileLoadbmp)
	ON_COMMAND(ID_EFFECTS_DARKNESS_LIGHT, OnEffectsDarknessLight)
	ON_COMMAND(ID_EFFECTS_DARKNESS_NORMAL, OnEffectsDarknessNormal)
	ON_COMMAND(ID_EFFECTS_DARKNESS_HEAVY, OnEffectsDarknessHeavy)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers
/*----------------------------------------------------------*/	
/* Metoda ta sluzu do okreslenia pierwotnych ustawien okna */
BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

/*----------------------------------------------------------*/
/*	Metoda sluy do odrysowania okna i jego zawartoci,
	uruchamia si automatycznie np po zaslonieciu okna */

void CChildView::OnPaint() 
{
	CPaintDC dc(this);
	CDC* pDC=GetDC();
	int j=0,i=0;	//do iteracji

	(*pDC).TextOut(20,3," Edit field");
	(*pDC).TextOut(400,3,"View");
	// Okrelienie stylu linii
	CPen lpen(PS_SOLID, 1, RGB(190,190,190));
	(*pDC).SelectObject(&lpen);
	(*pDC).SetBkColor(RGB(255,255,0));
	
	// Rysowanie linii siatki
	for (i=0;i<=tekstura.size_x;i++) rysuj_linie(20+5*i,20,20+5*i,340,pDC);
    for (i=0;i<=tekstura.size_y;i++) rysuj_linie(20,20+5*i,341,20+5*i,pDC);

	// Obwodka malej teksturki
	rysuj_linie(400, 19, 464, 19,pDC);		
	rysuj_linie(400,84,464,84,pDC);
	rysuj_linie(399,19,399,84,pDC);
	rysuj_linie(464,20,464,84,pDC);

	// Przerysowanie zawartosci z tablicy na ekran
	rysuj_bitmape(pDC);
	rysuj_teksturke(pDC);
	ReleaseDC( pDC );

}

/*----------------------------------------------------------*/
/*	prosta procedurka do kreslenia linii,wygodniejsza
	do uzycia od zlozenia MoveTo i LineTo*/

void CChildView::rysuj_linie(int x1, int y1, int x2, int y2, CDC * _dc)
{

(*_dc).MoveTo(x1,y1);
(*_dc).LineTo(x2,y2);

}


/*----------------------------------------------------------*/
/*	Obsuga ruchu myszy- jezeli jest wcisniety lewy przycisk myszki
	i kursor znajduje sie w obszarze edycyjnym to rysowana jest aktualnym 
	kolorem (curentColor) tekstura (i zapelniana odpowiednio tablica */


void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (((nFlags & MK_LBUTTON)==MK_LBUTTON)&&(point.x>20)&&(point.x<340)&&(point.y>20)&&(point.y<340)  )
	{
	if (is_drawing==false) undo_prepare();
	is_drawing=true;
	
	CDC *pDC=GetDC();	
	point.x-=point.x%5;			 //wyznaczenie na podstawie polozenie kursora
	point.y-=point.y%5;
	int cur_x=(point.x-20)/5;    //wspolerzednych do indeksowania "tekstury"
	int cur_y=(point.y-20)/5;
	tekstura.wstaw_pixel(cur_x,cur_y,currentColor);
	rysuj_kwadracik(pDC,point.x,point.y,currentColor);
	rysuj_teksturke(pDC);
	ReleaseDC( pDC );
	}
	CWnd ::OnMouseMove(nFlags, point);
}


/*----------------------------------------------------------*/
/*	Narysowanie pojedynczego elementu skladajacego sie na widok 
	pola edycyjnego 
	uzywane przez CChildView::rysuj_bitmape(CDC * _dc) */
	
void CChildView::rysuj_kwadracik(CDC *_dc,int x,int y,COLORREF _color)
{
	
	for(int i=1; i<5 ;i++)
	for(int j=1; j<5;j++)	(*_dc).SetPixel(x+i,y+j,_color);

}

/*----------------------------------------------------------*/
/*  Jeeli zosta wcinity lewy klawisz myszki to przekazuje
	to zdarzenie do zaimplementowanej obsugi ruchu myszy 
	umozliwia to wychwycenie i narysowanie czegos w polu 
	edycyjnym zarwno w ruchu myszki jak i w konkretnej pozycji */

void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
OnMouseMove(nFlags,point);
	
	CWnd ::OnLButtonDown(nFlags, point);
}

/*----------------------------------------------------------*/
/* Wyswietlenie teksturki w "malym polu" */
void CChildView::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	CColorDialog okienko( RGB(0,0,0), CC_SOLIDCOLOR, this);	// Stworzenie okienka dialogowego
															// do wybrania koloru
	
	if (okienko.DoModal() == IDOK)							// uruchomienie
	{
	currentColor = okienko.GetColor();
	}
	CWnd ::OnRButtonDblClk(nFlags, point);
}


/*----------------------------------------------------------*/
/* Wyswietlenie teksturki w "malym polu" */

void CChildView::rysuj_teksturke(CDC *_dc)
{
	for(int i=0;i<tekstura.size_y;i++)
	for(int j=0;j<tekstura.size_x;j++) (*_dc).SetPixel(400+i,20+j,tekstura.zwroc_kolor(i,j));
}


/*----------------------------------------------------------*/
/* Wyczyszczenie pola edycyjnego, wyczyszczenie bitmapki w pamieci */
/* wywolywane z paska Menu */
void CChildView::OnFileNew() 
{
	undo_prepare();
	tekstura.ustaw_kolor_w_tablicy(RGB(255,255,255)); 
	this->OnPaint();
	
	CDC *pDC=GetDC();
	tekstura.ustaw_kolor_w_tablicy(RGB(255,255,255));
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC(pDC);
}

/*----------------------------------------------------------*/
/* Ta metoda zachowuje tablice do pliku,
 wywoywane jest okienko dialogowe suce do zapisu */
/* wywolywane z paska Menu */
void CChildView::OnSave()	
{
	char* typy_plikow="format wasny (*.tex)|*.tex|format bmp (*.bmp)|*.bmp|";
	CFileDialog okno_do_zapisu_pliku( false, "tex", "bitmap01",OFN_OVERWRITEPROMPT, typy_plikow, this);
	
	if(okno_do_zapisu_pliku.DoModal()==IDOK)
	{
    
		// nazwa pliku do zapisania i jego sciezka pobierane sa z okienka dialogowego //ewntualna informacja przy nieudanym zapisie
		if(tekstura.SaveBitmapFile(okno_do_zapisu_pliku.GetPathName())) MessageBox("Nie mona byo zapisa pliku"+okno_do_zapisu_pliku.GetPathName());  
															  
	}
	
}

/*----------------------------------------------------------*/
/* Wywolanie okienka dialogowego do otworzenia pliku
	i otworzenie go, odswierzenie widoku 
	wywolywane z paska Menu */
void CChildView::OnFileOpen() 
{
	undo_prepare();
	CDC *pDC=GetDC();
	char* typy_plikow="format wasny (*.tex)|*.tex|";
	CFileDialog okno_do_odczytu_pliku( true, "tex", NULL,OFN_OVERWRITEPROMPT, typy_plikow, this);
	
	if(okno_do_odczytu_pliku.DoModal()==IDOK)
	{
    if(tekstura.OpenBitmapFile(okno_do_odczytu_pliku.GetPathName())) MessageBox("Nie mona byo odczyta pliku"+okno_do_odczytu_pliku.GetPathName());  
	
		// nazwa pliku do odczytu i jego sciezka pobierane sa z okienka dialogowego 
		//ewentualna informacja przy nieudanym zapisie
										  
	}
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );
}

/*----------------------------------------------------------*/
/* wyswietlenie bitmapy do obszaru edycji */

void CChildView::rysuj_bitmape(CDC * _dc)
{
for (int i=0;i<tekstura.size_y;i++)
for (int j=0;j<tekstura.size_x;j++) rysuj_kwadracik(_dc,i*5+20,j*5+20,tekstura.zwroc_kolor(i,j));
}

/*----------------------------------------------------------*/
/* zapelnienia bitmapki biezacym kolorem i wyswietlenie efektu*/
/* wywolywane z paska Menu */
void CChildView::OnEffectsEffect1() 
{
undo_prepare();
CDC *pDC = GetDC();	
	tekstura.ustaw_kolor_w_tablicy(currentColor);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
ReleaseDC( pDC );
}

/*----------------------------------------------------------*/
/* Konwertowanie kolorw do poziomw szaroci i wyswietlenie efektu*/
/* wywolywane z paska Menu */
void CChildView::OnEffectsGrayscale() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_grayscale();
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );
}


/*----------------------------------------------------------*/
/* rozjasnienie "Light" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */
void CChildView::OnEffectsBrightnessLight() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_brightness(20);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );
}

/*----------------------------------------------------------*/
/* rozjasnienie "Normal" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */
void CChildView::OnEffectsBrightnessNormal() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_brightness(50);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );
}

/*----------------------------------------------------------*/
/* rozjasnienie "Heavy" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */
void CChildView::OnEffectsBrightnessHeavy() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_brightness(100);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );	
}

/*----------------------------------------------------------*/
/* przyciemnienie "Light" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */

void CChildView::OnEffectsDarknessLight() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_darkness(20);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );
}


/*----------------------------------------------------------*/
/* przyciemnienie "Normal" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */

void CChildView::OnEffectsDarknessNormal() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_darkness(50);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );	
}


/*----------------------------------------------------------*/
/* przyciemnienie "Heavy" bitmapki i wyswietlenie efektu*/
/* wywolywane z paska Menu */

void CChildView::OnEffectsDarknessHeavy() 
{
	undo_prepare();
	CDC *pDC = GetDC();	
	tekstura.bmp_darkness(100);
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );	
}
	
	
/*----------------------------------------------------------*/
/* wywolanie okienka dialogowego do wyboru koloru
   wywolywane z paska Menu 
   okienka do wyboru koloru
   realizuje dokladnie to samo co podwojne nacisniecie prawego 
   przycisku myszy
*/
void CChildView::OnViewChoosecolordialog() 
{
	OnRButtonDblClk(1, CPoint(1,1));
}

/*----------------------------------------------------------*/
/*	wywolywane z paska Menu 
	skopiowanie bitmapki do jej kopii tj do tekstura_copy
*/
  
void CChildView::OnEditCopy() 
{
	for (int i=0;i<tekstura.size_y;i++)
	for (int j=0;j<tekstura.size_x;j++) 
		tekstura_copy.wstaw_pixel(i,j,tekstura.zwroc_kolor(i,j));
	is_copy_empty=false;
}



/*----------------------------------------------------------*/
/*	wywolywane z paska Menu 
	wklejenie bitmapki z jej kopii tj od tekstura_copy do
	tekstura, odswierzenie ekranu
	sprawdzam czy schowek jest zapelniony
*/

void CChildView::OnEditPaste() 
{
	if(is_copy_empty==false)
	{
		undo_prepare();
		CDC *pDC = GetDC();	
		for (int i=0;i<tekstura.size_y;i++)
		for (int j=0;j<tekstura.size_x;j++)  
			tekstura.wstaw_pixel(i,j,tekstura_copy.zwroc_kolor(i,j));
	
		rysuj_teksturke(pDC);
		rysuj_bitmape(pDC);
		ReleaseDC( pDC );
	}
	else 
		MessageBox("Clipboard is empty","Error");
}


/*----------------------------------------------------------*/
/*	wywolywane z paska Menu 
	zawartosc tekstury do tekstura_copy
	wyzerowanie tekstury
	odswierzenie ekranu
*/

void CChildView::OnEditCut() 
{
	undo_prepare();
	is_copy_empty=false;
	CDC *pDC = GetDC();	
	for (int i=0;i<tekstura.size_y;i++)
	for (int j=0;j<tekstura.size_x;j++)  
		tekstura_copy.wstaw_pixel(i,j,tekstura.zwroc_kolor(i,j));
	tekstura.ustaw_kolor_w_tablicy(RGB(255,255,255));
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );	
}

/*----------------------------------------------------------*/
void CChildView::OnFileLoadbmp() 
{
//		MessageBox("OpenBMP");
	
	
	char* typy_plikow="Windows BMP (*.bmp)|*.bmp|";
	
	CFileDialog okno_do_odczytu_pliku( true, "bmp", NULL,OFN_OVERWRITEPROMPT, typy_plikow, this);
	
	if(okno_do_odczytu_pliku.DoModal()==IDOK)
		{ 
		undo_prepare();
		/* Jesli sie DoModal==IDOK to mozna otworzyc plik bmp */
		CDC *pDC = GetDC();	// Przejecie kontekstu 
		CDC myDC;			// Kontekst pamieciowy - w nim narysuje bitmape
		HBITMAP hbmp=NULL;	// Wskaznik do bitmapy
		CBitmap bmp;		// Obliekt Cbitmap
		
		myDC.CreateCompatibleDC( pDC );
		hbmp=(HBITMAP)::LoadImage( AfxGetInstanceHandle(), 
			okno_do_odczytu_pliku.GetPathName(), IMAGE_BITMAP, 0,0, LR_CREATEDIBSECTION | LR_LOADFROMFILE);
		bmp.Attach(hbmp);
		myDC.SelectObject( &bmp );
		pDC->BitBlt( 400, 20, 64, 64, &myDC, 0, 0, SRCCOPY );
	

	
	for (int i=0;i<tekstura.size_y;i++)
	for (int j=0;j<tekstura.size_x;j++)  
	{
		
		tekstura.wstaw_pixel(i,j,pDC->GetPixel(i+400,j+20));
		pDC->SetPixel(i+400,j+20,RGB(0,0,0));
		
	}
	
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	myDC.DeleteDC();
	ReleaseDC( pDC );
	bmp.DeleteObject();

	
	}		
	
}


/*----------------------------------------------------------*/
/*	Skopiowanie zawartosci tekstury do tekstura_undo 
	sluzy do przywrocenia "poprzedniego" stanu */
void CChildView::undo_prepare()
{
for (int i=0;i<tekstura.size_x;i++)
for (int j=0;j<tekstura.size_y;j++) 
	tekstura_undo.wstaw_pixel(j,i,tekstura.zwroc_kolor(j,i));
}


/*----------------------------------------------------------*/
/*	wywolywane z paska Menu 
	cofniecie dzialania */

void CChildView::OnEditUndo() 
{
	CDC *pDC = GetDC();	
	for (int i=0;i<tekstura.size_x;i++)
	for (int j=0;j<tekstura.size_y;j++) 
	tekstura.wstaw_pixel(j,i,tekstura_undo.zwroc_kolor(j,i));
	rysuj_teksturke(pDC);
	rysuj_bitmape(pDC);
	ReleaseDC( pDC );	
}


/*----------------------------------------------------------*/
/*	obsluga tego zdazenia jes niezbedna zeby zapewnic prawidlowe
	dzialanie undo: jezeli lewy przycisk myszki zostanie podniesiony 
	to znaczy ze ktos przestal rysowac, zatem nastepne rysowanie musip
	przechodzic do kolejnego undo*/
void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{

	if ( (point.x>20)&&(point.x<340)&&(point.y>20)&&(point.y<340)  ) is_drawing=false;
	CWnd ::OnLButtonUp(nFlags, point);
}
